/*******************************************************************************
 * $Id: DNAMemorySML.cpp,v 1.2 2004/02/27 23:08:41 darling Exp $
 * This file is copyright 2002-2004 Aaron Darling.  All rights reserved.
 * Please see the file called COPYING for licensing, copying, and modification
 * rights.  Redistribution of this file, in whole or in part is prohibited
 * without express permission.
 ******************************************************************************/

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

// for all others, include the necessary headers (this file is usually all you
// need because it includes almost all "standard" wxWindows headers)
#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

#include "gnSequence.h"
#include "libMems/DNAMemorySML.h"


DNAMemorySML::DNAMemorySML(const uint8* table, const uint32 alpha_bits) : 
MemorySML( table, alpha_bits )
{}

DNAMemorySML& DNAMemorySML::operator=(const DNAMemorySML& msa ){
	MemorySML::operator=(msa);
	return *this;
}

DNAMemorySML* DNAMemorySML::Clone() const{
	DNAMemorySML *bdsa = new DNAMemorySML();
	(*bdsa) = *this;
	return bdsa;
}

uint64 DNAMemorySML::GetMer(gnSeqI position){
	return GetDnaMer( position );
}

void DNAMemorySML::FillSML(const gnSequence& seq, vector<bmer>& sml_array)
{
	FillDnaSML(seq, sml_array);
}
